=== debian/changelog ===
openal-soft (1:1.13-4ubuntu3) precise; urgency=low

  * Add a symbols file for libopenal1

 -- Rohan Garg <rohangarg@kubuntu.org>  Tue, 06 Mar 2012 17:39:30 +0100

openal-soft (1:1.13-4ubuntu2) precise; urgency=low

  * No-change rebuild to drop spurious libsfgcc1 dependency on armhf.

 -- Adam Conrad <adconrad@0c3.net>  Fri, 02 Dec 2011 21:02:19 -0700

openal-soft (1:1.13-4ubuntu1) precise; urgency=low

  * Mark libopenal-data Multi-Arch: foreign, so that it satisfies
    dependencies of the non-native versions of libopenal1.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 19 Oct 2011 16:25:55 -0700

openal-soft (1:1.13-4) unstable; urgency=low

  * Remove unnecessary use of patch to support multiarch.
  * Update Vcs-* entries.

 -- Andres Mejia <amejia@debian.org>  Sun, 25 Sep 2011 12:48:53 -0400

openal-soft (1:1.13-3) unstable; urgency=low

  * Update to my @debian.org email.
  * Set 'pristine-tar' to true by default.
  * Convert package to support multiarch libraries.
  * Support parallel builds.
  * Removed changes to compiler flags. Upstream does not want to set '-O3'.
  * Set option to abort on any upstream change.

 -- Andres Mejia <amejia@debian.org>  Sun, 25 Sep 2011 11:12:08 -0400

openal-soft (1:1.13-2) unstable; urgency=low

  * Don't build with ALSA compatibility on non-Linux architectures.

 -- Andres Mejia <mcitadel@gmail.com>  Fri, 22 Apr 2011 18:30:58 -0400

openal-soft (1:1.13-1) unstable; urgency=low

  * New upstream release.
  * Update Standards-Version to 3.9.2.
  * Use linux-any architecture wildcard for libasound2-dev build depends.
  * Build depend on liboss-salsa-dev for non-Linux architectures.
  * Build openal-soft with 'Release' configuration. This removes debugging
    package.
  * Use -O3 instead of -O2 compiler optimizations.

 -- Andres Mejia <mcitadel@gmail.com>  Fri, 22 Apr 2011 16:52:34 -0400

openal-soft (1:1.12.854-2) unstable; urgency=low

  * Remove Thierry Reding from Uploaders. (Closes: #572541)

 -- Andres Mejia <mcitadel@gmail.com>  Sat, 29 May 2010 12:39:55 -0400

openal-soft (1:1.12.854-1) unstable; urgency=low

  * New upstream release.

 -- Andres Mejia <mcitadel@gmail.com>  Sat, 29 May 2010 12:26:00 -0400
