=== debian/changelog ===
openal-soft (1:1.14-4ubuntu1) quantal; urgency=low

  * Merge from Debian testing.  Remaining changes:
    - Add a symbols file for libopenal1

 -- Felix Geyer <debfx@ubuntu.com>  Wed, 20 Jun 2012 12:01:20 +0200

openal-soft (1:1.14-4) unstable; urgency=medium

  * Drop libroar-compat2 to Suggests field. (Closes: #673178)
  * Drop libportaudio2 to Suggests field.

 -- Andres Mejia <amejia@debian.org>  Sat, 02 Jun 2012 10:20:29 -0400

openal-soft (1:1.14-3ubuntu1) quantal; urgency=low

  * Merge from Debian testing.  Remaining changes:
    - Add a symbols file for libopenal1
  * debian/libopenal1.symbols:
    - Update for 1.14

 -- Michael Terry <mterry@ubuntu.com>  Tue, 22 May 2012 10:14:53 -0400

openal-soft (1:1.14-3) unstable; urgency=low

  * Add dlopened libs as Recommends for libopenal1.
  * Dlopen libsndio.so.2 instead of libsndio.so.

 -- Andres Mejia <amejia@debian.org>  Sat, 05 May 2012 17:24:59 -0400

openal-soft (1:1.14-2) unstable; urgency=low

  * Fix build failures on architectures without _FPU_EXTENDED. (Closes: #666963)

 -- Andres Mejia <amejia@debian.org>  Tue, 01 May 2012 10:52:21 -0400

openal-soft (1:1.14-1) unstable; urgency=low

  * New upstream release.
  * Add CPPFLAGS to CFLAGS. (Closes: #666095)
  * Enable new sndio support.

 -- Andres Mejia <amejia@debian.org>  Sun, 01 Apr 2012 16:19:00 -0400

openal-soft (1:1.13-6) unstable; urgency=low

  * Enable hardened compiler flags.

 -- Andres Mejia <amejia@debian.org>  Mon, 19 Mar 2012 10:13:18 -0400

openal-soft (1:1.13-5) unstable; urgency=low

  * Set Multi-Arch: foreign for libopenal-data. (Closes: #645962)
  * Allow dev package to be multiarch installable.
  * Set Standards-Version to 3.9.3.

 -- Andres Mejia <amejia@debian.org>  Fri, 16 Mar 2012 16:47:13 -0400
