=== debian/control ===
--- 
+++ 
@@ -10,7 +10,8 @@
 Build-Depends: debhelper (>= 8.1.3~),
                libasound2-dev [linux-any],
                cmake, portaudio19-dev, libpulse-dev,
-Standards-Version: 3.9.2
+               libroar-dev | libsndio-dev,
+Standards-Version: 3.9.3
 Section: libs
 Vcs-Git: git://anonscm.debian.org/pkg-games/openal-soft.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-games/openal-soft.git
@@ -18,6 +19,7 @@
 DM-Upload-Allowed: yes
 
 Package: libopenal-dev
+Multi-Arch: same
 Section: libdevel
 Architecture: any
 Depends: libopenal1 (= ${binary:Version}),
@@ -52,6 +54,8 @@
 Depends: libopenal-data (= ${source:Version}),
          ${shlibs:Depends},
          ${misc:Depends}
+Recommends: ${shlibs:Recommends}
+Suggests: ${shlibs:Suggests}
 Description: Software implementation of the OpenAL API (shared library)
  OpenAL, the Open Audio Library, is a joint effort to create an open,
  vendor-neutral, cross-platform API for interactive, primarily spatialized
